// MainFrm.cpp : implementation of the CMainFrame class
//

#include "stdafx.h"
#include "progetto.h"

#include <ipl.h>
#include <highgui.h>
#include <cvcam.h>



#include "MainFrm.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

       // Dichiaro una IplImage che conterr l'immagine sorgente
       IplImage *sorgente, *sorgente_gray, *dst;

	   // Mi definisco tolleranza inizializzandola a 5 
	   int tolleranza=5;

  	   CString str="Finestra di threshold       soglia: ";

/////////////////////////////////////////////////////////////////////////////
// CMainFrame

IMPLEMENT_DYNCREATE(CMainFrame, CFrameWnd)

BEGIN_MESSAGE_MAP(CMainFrame, CFrameWnd)
	//{{AFX_MSG_MAP(CMainFrame)
	ON_WM_CREATE()
	ON_COMMAND(ID_FILE_OPEN, OnFileOpen)
	ON_COMMAND(ID_PROGETTO_SOGLIATURA, OnProgettoSogliatura)
	ON_COMMAND(ID_APP_EXIT, OnAppExit)
	ON_COMMAND(ID_PROGETTO_CHIUDIIMMAGINI, OnProgettoChiudiimmagini)
	ON_COMMAND(ID_PROGETTO_SCELTATOLLERANZA, OnProgettoSceltatolleranza)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

static UINT indicators[] =
{
	ID_SEPARATOR,           // status line indicator
	ID_INDICATOR_CAPS,
	ID_INDICATOR_NUM,
	ID_INDICATOR_SCRL,
};

/////////////////////////////////////////////////////////////////////////////
// CMainFrame construction/destruction

CMainFrame::CMainFrame()
{
	// TODO: add member initialization code here
	
}

CMainFrame::~CMainFrame()
{
}

int CMainFrame::OnCreate(LPCREATESTRUCT lpCreateStruct)
{
	if (CFrameWnd::OnCreate(lpCreateStruct) == -1)
		return -1;
	
	if (!m_wndToolBar.CreateEx(this, TBSTYLE_FLAT, WS_CHILD | WS_VISIBLE | CBRS_TOP
		| CBRS_GRIPPER | CBRS_TOOLTIPS | CBRS_FLYBY | CBRS_SIZE_DYNAMIC) ||
		!m_wndToolBar.LoadToolBar(IDR_MAINFRAME))
	{
		TRACE0("Failed to create toolbar\n");
		return -1;      // fail to create
	}

	if (!m_wndStatusBar.Create(this) ||
		!m_wndStatusBar.SetIndicators(indicators,
		  sizeof(indicators)/sizeof(UINT)))
	{
		TRACE0("Failed to create status bar\n");
		return -1;      // fail to create
	}

	// TODO: Delete these three lines if you don't want the toolbar to
	//  be dockable
	m_wndToolBar.EnableDocking(CBRS_ALIGN_ANY);
	EnableDocking(CBRS_ALIGN_ANY);
	DockControlBar(&m_wndToolBar);

	return 0;
}

BOOL CMainFrame::PreCreateWindow(CREATESTRUCT& cs)
{
	if( !CFrameWnd::PreCreateWindow(cs) )
		return FALSE;
	// TODO: Modify the Window class or styles here by modifying
	//  the CREATESTRUCT cs

	return TRUE;
}

/////////////////////////////////////////////////////////////////////////////
// CMainFrame diagnostics

#ifdef _DEBUG
void CMainFrame::AssertValid() const
{
	CFrameWnd::AssertValid();
}

void CMainFrame::Dump(CDumpContext& dc) const
{
	CFrameWnd::Dump(dc);
}

#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CMainFrame message handlers


void CMainFrame::OnFileOpen() 
{


       // Dichiaro una stringa di caratteri che mi conterra il nome e il percorso dell'immagine da caricare
       char path[256];

       // Inizializzo "path"
       memset(path,0,256);

       // Scelgo il file da aprire attraverso la finestra open-file
       OPENFILENAME fn;
       fn.lStructSize = sizeof (OPENFILENAME);
       fn.hwndOwner = NULL;
       fn.lpstrFilter = NULL;
       fn.lpstrFile = path; // in "path" verra conservato il file selezionato
       fn.nMaxFile = 256;   // fisso la lunghezza massima del nome del file (compreso il percorso) selezionato a 256
       fn.lpstrFileTitle = NULL;
       fn.lpstrInitialDir = NULL;
       fn.lpstrTitle = NULL;
       fn.Flags = NULL;
       fn.lpstrDefExt = "bmp"; // specifico che mi interessano solo file *.bmp
       //fn.hInstance = DLLhinst;
       fn.lpfnHook = NULL;
       fn.lpstrCustomFilter = NULL;
       fn.lCustData = NULL;
       if(!GetOpenFileName(&fn))
       {
         //AfxErrorBox("Errore nell'apertura del file");
         // non se se esiste, eventualmente utilizzare AfxMessageBox("Errore nell'apertura del file");
         return; // se c' stato un errore nell'aprire il file specificato esco dalla funzione
       }

       // Creo la finetsra che conterr l'Immagine originale
       cvNamedWindow("finestra colore",CV_WINDOW_AUTOSIZE);

       // Carico limmagine contenuta nel file selezionato tramite la dialog box open-file)
       sorgente=cvLoadImage(path);

       // Mostro nella finestra "window color" limmagine contenuta in "sorgente" cio l'immagine originale
       cvShowImage("finestra colore",sorgente); 

}

void CMainFrame::OnProgettoSogliatura() 
{

       // Creo la variabile "size_sorgente" di tipo "CvSize" per contenere larghezza ed altezza dellimmagine
       CvSize size_sorgente=cvSize(sorgente->width,sorgente->height);

       // Creo limmagine "sorgente_gray" con le dimensioni fissate da "size_sorgente" e con un solo canale
       sorgente_gray=cvCreateImage(size_sorgente,sorgente->depth,1);

       // Converto l'immagine "sorgente" a toni di grigio passandola alla variabile sorgente_gray
       iplColorToGray(sorgente,sorgente_gray);

       // Creo la finestra che conterr l'Immagine a toni di grigio.
       // La costante "CV_WINDOW_AUTOSIZE" richiede che la window si adatti alle dimensioni dellimmagine
       cvNamedWindow("window gray",CV_WINDOW_AUTOSIZE);

       // Mostro a video limmagine a toni di grigio
       cvShowImage("window gray",sorgente_gray);

       // Creo limmagine "dst" con le dimensioni fissate da "size_sorgente" e con un solo canale
       dst=cvCreateImage(size_sorgente,sorgente->depth,1);

       // Copio di "sorgente_gray" in "dst"
       cvCopyImage (sorgente_gray,dst);

       // Qui metter il valore del pixel letto
       unsigned char pixel;

       // Dichiaro "bk" e "fr"
       int bk, fr;

       int numbk=4;

       // Dichiaro "numfr" e la inizializzo al valore corrispondente al numero dei piexl dell'immagine meno "numbk"
       int numfr=(dst->width*dst->height)-numbk;

       // Metter in "bk" la somma dei valori dei pixel posti ai vertici dell'immagine a toni di grigio
       // Inizializzo "bk" a zero
       bk=0;
            // Leggo il valore del pixel in alto a sinistra e lo aggiungo a "bk"
                // Prendo il valore del pixel di coordinate (0,0)
                iplGetPixel(dst,0,0,&pixel);
                // Sommo "pixel" a "bk"
                bk=bk+pixel;
           // Leggo il valore del pixel in alto a destra e lo aggiungo a "bk"
                // Coordinate x,y del pixel da leggere
                // Prendo il valore del pixel di coordinate (0,(dst->width)-1)
                iplGetPixel(dst,(dst->width)-1,0,&pixel);
                // Sommo "pixel" a "bk"
                bk=bk+pixel;
           // Leggo il valore del pixel in basso a sinistra e lo aggiungo a "bk"
                // Coordinate x,y del pixel da leggere
                // Prendo il valore del pixel di coordinate ((dst->height)-1,0)
                iplGetPixel(dst,0,(dst->height)-1,&pixel);
                // Sommo "pixel" a "bk"
                bk=bk+pixel;
           // Leggo il valore del pixel in basso a destra e lo aggiungo a "bk"
                // Coordinate x,y del pixel da leggere
                // Prendo il valore del pixel di coordinate ((dst->height)-1,(dst->width)-1)
                iplGetPixel(dst,(dst->width)-1,(dst->height)-1,&pixel);
                // Sommo "pixel" a "bk"
                bk=bk+pixel;

       // Metter in "fr" la somma dei valori dei pixel di tutta l'immagine meno i pixel dei vertici
       // Inizializzo "fr" a zero
       fr=0;
	   int i,j;
       // Scorro tutta l'immagine
       for(i=0; i<dst->width; i++)
           for(j=0; j<dst->height; j++)
           {
              // Leggo il valore del pixel di coordinate i,j
              iplGetPixel(dst,i,j,&pixel);
              // Sommo "pixel" a "fr"
              fr=fr+pixel;
           }
       // Tolgo a "fr" il valore di "bk"
       fr=fr-bk;

       // Calcolo la media "mbk" dei valori che i pixel hanno ai quattro vertici
       int mbk=(bk/numbk);

       // Calcolo la medi "mfr" dei valori che i pixel hanno sull'intera immagine tranne ai quattro vertici
       int mfr=(fr/numfr);

       // Fisso il valore di threshold come media delle medie di "bk" e "fr"
       int sogliaPrec=int((mbk+mfr)/2);

       // Definisco la varibile "soglia" che conterr la soglia per l'operazione di thresholding
       int soglia=sogliaPrec;

       // Applico pi volte l'operazione di thresholding fin quando la soglia calcolata si discosta dalla
       // precedente massimo di 5 unit
       do
            {
             sogliaPrec=soglia;
             fr=0;
             numfr=0;
             bk=0;
             numbk=0;
             // Scorro tutta l'immagine
             for(i=0; i<dst->width; i++)
             for(j=0; j<dst->height; j++)
             {
                // Leggo il valore del pixel di coordinate i,j
                iplGetPixel(dst,i,j,&pixel);
                // Confronto il valore "pixel" col valore di soglia
                if (pixel < soglia)
                  {
                     numbk++;
                     bk=bk+pixel;
                  }
                else
                  {
                     numfr++;
                     fr=fr+pixel;
                  }
             }
            mbk=bk/numbk;
            mfr=fr/numfr;
            soglia=int((mbk+mfr)/2);
			}
       while (abs(soglia-sogliaPrec)>tolleranza);

       // Applico l'operazione di thresholding a "sorgente_gray" passando il risultato a "dst"
       iplThreshold(sorgente_gray, dst,soglia);

       // Creo "stringa" nella quale metter il valore di "soglia" convertito in array di caratteri
	   char threshold[3];
	   _itoa(soglia, threshold, 10);

	   // Concateno 2 stringhe
	   str=str+threshold;     //overloading delloperatore "+"

       // Creo la finetsra che conterr l'immagine sogliata.
       // La costante "CV_WINDOW_AUTOSIZE" richiede che la window si adatti alle dimensioni dellimmagine
       cvNamedWindow(str,CV_WINDOW_AUTOSIZE);

	   // Mostro a video limmagine sogliata
       cvShowImage(str,dst);

}

void CMainFrame::OnAppExit() 
{

       
}

void CMainFrame::OnProgettoChiudiimmagini() 
{

	   // Elimino le tre finestre dallo schermo
       cvDestroyWindow("finestra colore");
       cvDestroyWindow("window gray");
       cvDestroyWindow(str);

       // Rilascio la memoria allocata per le tre immagini
       cvReleaseImage (&sorgente);
       cvReleaseImage (&sorgente_gray);
       cvReleaseImage (&dst);
	
}

void CMainFrame::OnProgettoSceltatolleranza() 
{

	// TODO: Add your command handler code here
	
}
