// voxDoc.cpp : implementation of the CVoxDoc class
//

#include "stdafx.h"
#include "vox.h"
#include "math.h"

#include "voxDoc.h"

#include <ipl.h>
#include <highgui.h>
#include <cvcam.h>

HINSTANCE DLLhinst;
#define DIMENSION_SIZE 256

typedef IplImage* IPLIMAGE;

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CVoxDoc

IMPLEMENT_DYNCREATE(CVoxDoc, CDocument)

BEGIN_MESSAGE_MAP(CVoxDoc, CDocument)
	//{{AFX_MSG_MAP(CVoxDoc)
	ON_COMMAND(ID_ESEGUI_ISTOGRAMMA, OnEseguiIstogramma)
	ON_COMMAND(ID_ESEGUI_FILTRODISOBEL, OnEseguiFiltrodiSobel)
	ON_COMMAND(ID_ESEGUI_LAPLACIANO, OnEseguiLaplaciano)
	ON_COMMAND(ID_ESEGUI_SOBELLAPLACIANO, OnEseguiSobellaplaciano)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CVoxDoc construction/destruction

CVoxDoc::CVoxDoc()
{
	// TODO: add one-time construction code here

}

CVoxDoc::~CVoxDoc()
{
}

BOOL CVoxDoc::OnNewDocument()
{
	if (!CDocument::OnNewDocument())
		return FALSE;

	// TODO: add reinitialization code here
	// (SDI documents will reuse this document)

	return TRUE;
}



/////////////////////////////////////////////////////////////////////////////
// CVoxDoc serialization

void CVoxDoc::Serialize(CArchive& ar)
{
	if (ar.IsStoring())
	{
		// TODO: add storing code here
	}
	else
	{
		// TODO: add loading code here
	}
}

/////////////////////////////////////////////////////////////////////////////
// CVoxDoc diagnostics

#ifdef _DEBUG
void CVoxDoc::AssertValid() const
{
	CDocument::AssertValid();
}

void CVoxDoc::Dump(CDumpContext& dc) const
{
	CDocument::Dump(dc);
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CVoxDoc commands

void CVoxDoc::OnEseguiIstogramma() 
{
	// TODO: Add your command handler code here
			char path[256];
		//Inizializzazione di path
		memset(path,0,256);
		//scelgo il file da aprire attraverso la finestra open-file
		OPENFILENAME fn;
		fn.lStructSize = sizeof (OPENFILENAME);
		fn.hwndOwner = NULL;
		fn.lpstrFilter = NULL;
		fn.lpstrFile = path;
		fn.nMaxFile = 256;
		fn.lpstrFileTitle = NULL;
		fn.lpstrInitialDir = NULL;
		fn.lpstrTitle = NULL;

		fn.Flags = NULL;
		fn.lpstrDefExt = "bmp";
		fn.hInstance = DLLhinst;
		fn.lpfnHook = NULL;
		fn.lpstrCustomFilter = NULL;
		fn.lCustData = NULL;
		if(!GetOpenFileName(&fn))
		return ;
		
		char wndname01[] = "Source image";
		char wndname02[] = "Histogram";
		
		//#define DIMENSION_SIZE 50
		
		int dims[1] = {DIMENSION_SIZE}; //numero di barre per dimensione
		float thresh[1][2] = { {0, 255} }; // range di valori da analizzare
		float * pthresh[1] = { thresh[0] };

		IPLIMAGE image01 = cvLoadImage( path );
		// alias per IplImage* definito in highgui.h
		// typedef IplImage* IPLIMAGE;
		
		IplImage * image02 = cvCreateImage( cvSize(image01-> width,
		image01->height), IPL_DEPTH_8U, 1);
		
		 
		IplImage * image03 = cvCreateImage( cvSize(image01-> width,
		image01->height), IPL_DEPTH_8U, 3);
		// converto limmagine da colore a toni di grigio
		
		iplColorToGray(image01,image02);
		// creo l header dellistogramma.
		CvHistogram* hist01 = cvCreateHist(1, dims, CV_HIST_ARRAY,
		0, 1);
		// 1: numero di dimensioni dellistogramma.
		// dims: size dellarray.
		// CV_HIST_ARRAY: tipo dellistogramma.
		// 1: i bins (barre) sono distribuiti uniformemente.
		CvHistogram* hist02 = cvCreateHist(1, dims, CV_HIST_ARRAY,
		0, 1);

		cvSetHistBinRanges( hist01, pthresh, 1);
		// hist01: istogramma destinazione.
		// pthresh: puntatore ai valori limite dellarray.
		// 1: i bins sono distribuiti uniformemente.


		cvNamedWindow( wndname01, CV_WINDOW_AUTOSIZE );
		cvNamedWindow( wndname02, CV_WINDOW_AUTOSIZE );
		cvShowImage( wndname01, image02 );
		
		// Calculated the histogram.
		cvCalcHist( &image02, hist01, 0, 0 );
		// immagine sorgente.
		// puntatore allistogramma.
		// Clear flag = 0 : listogramma viene azzerato prima del calcolo.
		// IplImage* mask=0


		// preludio al tracciamento dellistogramma.
		int i;
		CvPoint pt1, pt2;
		pt2.x=0;
		pt2.y= (image01->height - 1) ;
		pt1.x=0;
		pt1.y=0;
		
		cvSetZero(image03); // sfondo nero per limmagine dellistogramma			
		
		//copio listogramma 1 nellistogramma 2.
		cvCopyHist(hist01, &hist02);
		// hist01: istogramma sorgente.
		// &hist02: puntatore allistogramma destinazione.

		float minVal[1];
		float maxVal[1];
		int minIdx[1];
		int maxIdx[1];
		// calcolo di minimo e massimo dellistogramma
		// per adattare listogramma alle dimensioni dellimmagine
		cvGetMinMaxHistValue (hist02, minVal,
		maxVal, minIdx, maxIdx);
		int bins;


		//tracciamento dellistogramma
		for(i=0; i<DIMENSION_SIZE; i++)
		{		
				pt1.x=pt1.x+1;
				// La funzione cvQueryHistValue_1D( )
				// restituisce il valore del bin specificato.
				bins=int cvQueryHistValue_1D(hist02,i);
				// normalizzazione dei "bin" alle dimensioni dellimmagine
				// (image03).
				int valore=int((image01->height)*(bins/maxVal[0]));
				pt1.y=image01->height - valore;
				pt2.x=pt2.x+1;
				cvLine(image03, pt1, pt2, CV_RGB(200,0,0), 2, 8);
				// CV_RGB(200,0,0): definisco un colore avente le
				// componenti R=200, G=0, B=0.
				// 2: spessore della linea, 8: connettivit adottata.

		}

		// show delle immagini e release della memoria
		cvShowImage( wndname02, image03 );

		cvWaitKey(0);
		cvDestroyWindow(wndname01);
		cvDestroyWindow(wndname02);
		cvReleaseImage(&image01);
		cvReleaseImage(&image02);
		cvReleaseImage(&image03);
		cvReleaseHist( &hist01 );
		cvReleaseHist( &hist02 );

}

void CVoxDoc::OnEseguiFiltrodiSobel() 
{
	// TODO: Add your command handler code here
			char path[256];
		memset(path,0,256);
		//scelgo il file da aprire attraverso la finestra open-file
		OPENFILENAME fn;
		fn.lStructSize = sizeof (OPENFILENAME);
		fn.hwndOwner = NULL;
		fn.lpstrFilter = NULL;
		fn.lpstrFile = path;
		fn.nMaxFile = 256;
		fn.lpstrFileTitle = NULL;
		fn.lpstrInitialDir = NULL;
		fn.lpstrTitle = NULL;

		fn.Flags = NULL;
		fn.lpstrDefExt = "bmp";
		fn.hInstance = DLLhinst;
		fn.lpfnHook = NULL;
		fn.lpstrCustomFilter = NULL;
		fn.lCustData = NULL;
		if(!GetOpenFileName(&fn))
		return ;
		
		IplImage *src ;
		IplImage *src_gray ;
		IplImage *dst ;
		/* */

		src=cvLoadImage(path);
		CvSize size_src=cvSize(src->width,src->height);
		src_gray=cvCreateImage(size_src,src->depth,1);
		dst=cvCreateImage(size_src,IPL_DEPTH_16S,1);
		IplImage * dst1;
		dst1=cvCreateImage(size_src,IPL_DEPTH_32F,1);
		IplImage * dst2;
		dst2=cvCreateImage(size_src,IPL_DEPTH_8U,1);


		iplColorToGray(src,src_gray);
		cvSobel (src_gray, dst, 1, 1);
		iplAbs(dst, dst);
		cvConvertScale (dst, dst1, 1.0,0.0);
		float minVal1;
		float maxVal1;
		iplMinMaxFP (dst1, &minVal1, &maxVal1);
		float value=255/maxVal1;



		iplMultiplySFP(dst1, dst1, value);
		cvConvertScale (dst1, dst2, 1.0,0.0);
		int threshold;

		threshold = 100 ;

		//acquisisco il valore di threshold da una dialog box ...
		cvThreshold(dst2, dst2, threshold, 255, CV_THRESH_BINARY);
		cvNamedWindow("window dst", CV_WINDOW_AUTOSIZE);
		cvShowImage("window dst", dst2);


		// apro una finestra denominata window gray
		cvNamedWindow("window gray",
		CV_WINDOW_AUTOSIZE);
		cvShowImage("window gray", src_gray);
		int dims[1] = {DIMENSION_SIZE};
		float thresh[1][2] = { {0, 255} };
		float* pthresh[1] = { thresh[0] };
		IplImage * image03= cvCreateImage(cvSize(300,300),
		IPL_DEPTH_8U, 3);


		//Created histogram headers. OpenCV use.
		CvHistogram* hist01 = cvCreateHist(1, dims,
		CV_HIST_ARRAY, pthresh, 1);
		cvNamedWindow( "hist", CV_WINDOW_AUTOSIZE );
		//Calculated the histogram. OpenCV use.
		cvCalcHist( &src_gray, hist01, 0, 0 );
		//Normalize and Draw histogram.
		int i; CvPoint pt1, pt2; pt2.x=0;

		pt2.y=(image03->height -1);
		pt1.x=0; pt1.y=0;
		cvSetZero(image03);
		float minVal[1], maxVal[1];
		int minIdx[1], maxIdx[1];
		cvGetMinMaxHistValue (hist01, minVal, maxVal, minIdx,
		maxIdx);
		float bins;

		// Draw histogram.
		for(i=0; i<DIMENSION_SIZE; i++)
		{
			pt1.x=pt1.x+1;
			//The function cvQueryHistValue_1D() returns the
			//value of the specified histogram bin.
			bins=cvQueryHistValue_1D(hist01,i);
			int valore;
			valore=int((image03->height)*(bins/maxVal[0]));
			pt1.y=image03->height - valore;
			pt2.x=pt2.x+1;
			cvLine(image03, pt1, pt2, CV_RGB(255,0,0), 2,
			8);
		}
		
		unsigned char pixel[1], pixel_mask[1];
		int istogramma[256];


		for(i=0; i<256; i++) 
			istogramma[i]=0;
		for(i=0; i<src_gray->height; i++)
		{ 
			for(int j=0; j<src_gray->width; j++)
			{
				iplGetPixel(dst2,j,i,pixel_mask);
				if(pixel_mask[0]>127)
				{
					iplGetPixel(src_gray,j,i,pixel);
	
					istogramma[pixel[0]]++;
				}
			}
		}
		int maximum=istogramma[0];
		for(i=1;i<256;i++)
		if(istogramma[i]>maximum) 
			maximum=istogramma[i];
		
		cvNamedWindow( "hist1", CV_WINDOW_AUTOSIZE);
		IplImage * image04 = cvCreateImage( cvSize(300,300),
		IPL_DEPTH_8U, 3);
		cvSetZero(image04);
		pt2.x=0; pt2.y=(image04->height -1);
		pt1.x=0; pt1.y=0;

		for(i=0; i<DIMENSION_SIZE; i++)
		{ 
			pt1.x=pt1.x+1;
			// The function cvQueryHistValue_1D() returns the
			// value of the specified histogram bin.
			bins=istogramma[i];
			int valore;
			valore=int((image04->height)*(bins/(float)maximum));
			pt1.y=image04->height - valore;
			pt2.x=pt2.x+1;
			cvLine(image04, pt1, pt2, CV_RGB(255,0,0), 2, 8);
		}
		// Show the image. HighGUI use.
		cvShowImage( "hist", image03 );
		cvShowImage( "hist1", image04 );
		cvWaitKey(0);
		cvDestroyWindow("window dst");
		cvDestroyWindow("window gray");
		cvDestroyWindow("hist");
		cvDestroyWindow("hist1");

		cvReleaseImage (&src);
		cvReleaseImage (&src_gray);
		cvReleaseImage (&dst);
		cvReleaseImage (&dst1);
		cvReleaseImage (&dst2);
		cvReleaseImage (&image03);
		cvReleaseImage (&image04);


}

void CVoxDoc::OnEseguiLaplaciano() 
{
	// TODO: Add your command handler code here
	char path[256];
		memset(path,0,256);
		//scelgo il file da aprire attraverso la finestra open-file
		OPENFILENAME fn;
		fn.lStructSize = sizeof (OPENFILENAME);
		fn.hwndOwner = NULL;
		fn.lpstrFilter = NULL;
		fn.lpstrFile = path;
		fn.nMaxFile = 256;
		fn.lpstrFileTitle = NULL;
		fn.lpstrInitialDir = NULL;
		fn.lpstrTitle = NULL;

		fn.Flags = NULL;
		fn.lpstrDefExt = "bmp";
		fn.hInstance = DLLhinst;
		fn.lpfnHook = NULL;
		fn.lpstrCustomFilter = NULL;
		fn.lCustData = NULL;
		if(!GetOpenFileName(&fn))
		return ;

		IplImage *src ;
		IplImage *src_gray ;
		IplImage *dst ;


	src=cvLoadImage(path);
	CvSize size_src=cvSize(src->width,src->height);
	src_gray=cvCreateImage(size_src,src->depth,1);
	dst=cvCreateImage(size_src,IPL_DEPTH_16S,1);
	IplImage * dst1, * dst2, * dsts, * dst32;
	dst1=cvCreateImage(size_src,IPL_DEPTH_32F,1);
	dst2=cvCreateImage(size_src,IPL_DEPTH_8U,1);
	dsts=cvCreateImage(size_src,IPL_DEPTH_16S,1);
	dst32=cvCreateImage(size_src,IPL_DEPTH_32F,1);
	iplColorToGray(src,src_gray);
	
	cvLaplace (src_gray, dsts);

	cvConvertScale (dsts, dst32, 1.0,0.0);
	cvSobel (src_gray, dst, 1, 1);
	iplAbs(dst, dst);
	cvConvertScale (dst, dst1, 1.0,0.0);
	float minVal1, maxVal1;
	iplMinMaxFP (dst1, &minVal1, &maxVal1);
	float value=255/maxVal1;
	iplMultiplySFP(dst1, dst1, value);
	cvConvertScale (dst1, dst2, 1.0,0.0);
	int threshold;

	threshold = 50;

	cvThreshold(dst2, dst2,threshold,255,CV_THRESH_BINARY);
	cvNamedWindow("window dst", CV_WINDOW_AUTOSIZE);
	cvShowImage("window dst",dst2);
	cvNamedWindow("window gray", CV_WINDOW_AUTOSIZE);
	cvShowImage("window gray",src_gray);
	int bins,i; CvPoint pt1, pt2;
	unsigned char pixel[1], pixel_mask[1];
	float pixel_s[1];
	int istogramma[256];
	for(i=0; i<256; i++) istogramma[i]=0;

	for(i=0; i<src_gray->height; i++)
	{ 
		for(int j=0; j<src_gray->width; j++)
			{
				iplGetPixel(dst2,j,i,pixel_mask);
				iplGetPixel(dst32,j,i,pixel_s);
				if((pixel_mask[0]>127)&&(pixel_s[0]<0))
				{ //sfondo: pixel_s[0]<0, oggetto: pixel_s[0]>0
					iplGetPixel(src_gray,j,i,pixel);
					istogramma[pixel[0]]++;
				}
			}
	}


	int maximum=istogramma[0];
	for(i=1;i<256;i++)
	if(istogramma[i]>maximum) maximum=istogramma[i];
	cvNamedWindow( "hist1", CV_WINDOW_AUTOSIZE );
	IplImage * image04 = cvCreateImage( cvSize(300,300),
	IPL_DEPTH_8U, 3);
	cvSetZero(image04);
	pt2.x=0; pt2.y=(image04->height -1);
	pt1.x=0; pt1.y=0;

	for(i=0; i<DIMENSION_SIZE; i++)
	{
		pt1.x=pt1.x+1; bins=istogramma[i];
		int valore=int((image04->height)*(bins/(float)maximum));
		pt1.y=image04->height - valore;
		pt2.x=pt2.x+1;
		cvLine(image04, pt1, pt2, CV_RGB(255,0,0), 2, 8);
	}
	cvShowImage( "hist1", image04 );
	cvWaitKey(0);
	//chiude le window aperte e libera la memoria allocata
	cvDestroyWindow("window dst");
	cvDestroyWindow("window gray");
	cvDestroyWindow("hist");
	cvDestroyWindow("hist1");
	cvReleaseImage (&src);
	cvReleaseImage (&src_gray);
	cvReleaseImage (&dst);
	cvReleaseImage (&dst1);
	cvReleaseImage (&dst2);

	cvReleaseImage (&image04);
	
}

void CVoxDoc::OnEseguiSobellaplaciano() 
{
	// TODO: Add your command handler code here
		// Procedura di apertura file

			char path[256];
			memset(path,0,256);
			OPENFILENAME fn;
			fn.lStructSize = sizeof (OPENFILENAME);
			fn.hwndOwner = NULL;
			fn.lpstrFilter = NULL;
			fn.lpstrFile = path;
			fn.nMaxFile = 256;
			fn.lpstrFileTitle = NULL;
			fn.lpstrInitialDir = NULL;
			fn.lpstrTitle = NULL;
			fn.Flags = NULL;
			fn.lpstrDefExt = "bmp";
			fn.hInstance = DLLhinst;
			fn.lpfnHook = NULL;
			fn.lpstrCustomFilter = NULL;
			fn.lCustData = NULL;
			if(!GetOpenFileName(&fn))
				return ;	

			// conversione a toni di grigio e visualizzazione
			IplImage *src, *src_gray, *src_gray1;

			src=cvLoadImage(path);
			
	
			CvSize size_src=cvSize(src->width,src->height);
			
			src_gray=cvCreateImage(size_src,src->depth,1);
			src_gray1=cvCreateImage(size_src,src->depth,1);
			
			iplColorToGray(src,src_gray);
			
			cvNamedWindow("window gray", CV_WINDOW_AUTOSIZE);
			cvShowImage("window gray",src_gray);
			
			
			// creazione delle immagini nei vari formati
			IplImage *dst16s1, *dst32f1, *dst8u, *dst16s2, *dst32f2;
			
			dst16s1=cvCreateImage(size_src,IPL_DEPTH_16S,1);
			dst32f1=cvCreateImage(size_src,IPL_DEPTH_32F,1);
			dst8u=cvCreateImage(size_src,IPL_DEPTH_8U,1);
			dst16s2=cvCreateImage(size_src,IPL_DEPTH_16S,1);
			dst32f2=cvCreateImage(size_src,IPL_DEPTH_32F,1);

			// applicazione del filtro sobel e conversione di scala
			cvSobel (src_gray, dst16s1, 1, 1);
			iplAbs(dst16s1, dst16s1);
			cvConvertScale (dst16s1, dst32f1, 1.0,0.0);
			
			float minVal1, maxVal1;
			iplMinMaxFP (dst32f1, &minVal1, &maxVal1);
			float value=255/maxVal1;
			iplMultiplySFP(dst32f1, dst32f1, value);
			cvConvertScale (dst32f1, dst8u, 1.0,0.0);


			// applicazione del filtro laplaciano e conversione
			cvLaplace (src_gray, dst16s2);
			cvConvertScale (dst16s2, dst32f2, 1.0,0.0);


			// individuazione dei punti di maggiore edgeness e visualizzazione di questi
			int threshold;
			threshold=30;
			
			cvThreshold(dst8u, dst8u,threshold,255,CV_THRESH_BINARY);
			
			cvNamedWindow("window Threshold of Sobel", CV_WINDOW_AUTOSIZE);
			cvShowImage("window Threshold of Sobel",dst8u);

			// inizializzazione e calcolo degli istogrammi
			unsigned char pixel_gray[1], pixel_mask[1];
			float pixel[1];

			int istogrammac[256];
			int istogrammas[256];
			
			for(int i=0; i<256; i++)
			{
				istogrammac[i]=0;
				istogrammas[i]=0;
			}
			
			
			
	// Consideriamo ogni pixel dell'immagine a toni di grigio, ne assegnamo il 
	// valore alla variabile pixel_mask, valutiamo, quindi, se tale pixel ha un 
	// elevato edgeness.
	// Solo sui punti che presentano un elevato edgeness andiamo a studiare il
	// segno del Laplaciano.
	// In base al segno viene eseguito l'incremento dell'istogramma relativo :
	// quello dei punti scuri e quello dei punti chiari.


			
			for(i=0; i<src_gray->height; i++)
			{ 
				for(int j=0; j<src_gray->width; j++)
				{
					iplGetPixel(dst8u,j,i,pixel_mask);
					if(pixel_mask[0]>127)
					{
						iplGetPixel(src_gray,j,i,pixel_gray);
						iplGetPixel(dst32f2,j,i,pixel);
						
						if(pixel[0]<0)
						
							istogrammac[pixel_gray[0]]++;
						
						else
						
							istogrammas[pixel_gray[0]]++;
					
						
					}
				}
			}

			
			
			// ricerca del massimo di ogni istogramma
			int maximumc=istogrammac[0];
			int maximums=istogrammas[0];
			
			for(i=1; i<256; i++)
			{
				if(istogrammac[i]>maximumc) 
					maximumc=istogrammac[i];
				
				if(istogrammas[i]>maximums) 
					maximums=istogrammas[i];
			}

			// rappresentazione degli istogrammi
			int binsc, binss;
			CvPoint pt1c, pt2c, pt1s, pt2s;
			IplImage *imagec = cvCreateImage( cvSize(300,300),IPL_DEPTH_8U, 3);
			IplImage *images = cvCreateImage( cvSize(300,300),IPL_DEPTH_8U, 3);
			
			cvSetZero(imagec);  // Sfondo nero per ogni istogramma
			cvSetZero(images);
			
			pt2c.x=0; pt2c.y=(imagec->height -1);
			pt1c.x=0; pt1c.y=0;
			pt2s.x=0; pt2s.y=(images->height -1);
			pt1s.x=0; pt1s.y=0;

			for(i=0; i<256; i++)
			{
				pt1c.x=pt1c.x+1; 
				binsc=istogrammac[i];
				int valorec=int((imagec->height)*(binsc/(float)maximumc));
				pt1c.y=imagec->height - valorec;
				pt2c.x=pt2c.x+1;
				cvLine(imagec, pt1c, pt2c, CV_RGB(255,0,0), 2, 8);

				pt1s.x=pt1s.x+1; 
				binss=istogrammas[i];
				int valores=int((images->height)*(binss/(float)maximums));
				pt1s.y=images->height - valores;
				pt2s.x=pt2s.x+1;
				cvLine(images, pt1s, pt2s, CV_RGB(0,0,255), 2, 8);
			}

			// visualizzazione degli istogrammi
			cvNamedWindow( "hist_chiari", CV_WINDOW_AUTOSIZE );
			cvShowImage( "hist_chiari", imagec );

			cvNamedWindow( "hist_scuri", CV_WINDOW_AUTOSIZE );
			cvShowImage( "hist_scuri", images );

			// calcolo dei valori medi e della soglia ottima nell'ipotesi P1=P2=0.5
			int nc, ns, dc, ds;
			nc=0;
			ns=0;
			dc=0;
			ds=0;
			
			for(i=0; i<256; i++)
			{
				dc=istogrammac[i]+dc;
				ds=istogrammas[i]+ds;
				nc=i*istogrammac[i]+nc;
				ns=i*istogrammas[i]+ns;
			}
			int thres, mediac, medias;
			mediac = 0;
			medias = 0;
			thres = 0;

			mediac=int(nc/dc);
			medias=int(ns/ds);
			thres=int((mediac+medias)/2);

			//Thresholding con soglia ottima e visualizzazione
			
			cvThreshold(src_gray, src_gray1 ,thres ,255,CV_THRESH_BINARY);
		
			cvNamedWindow("window Optimal Threshold",CV_WINDOW_AUTOSIZE);
			cvShowImage("window Optimal Threshold",src_gray1);
			

			
			// calcolo delle varianze
			int sigc, sigs;
			sigc=0;
			sigs=0;
			
			for(i=0; i<=255; i++)
			{
				sigc=((i-mediac)*(i-mediac)*istogrammac[i]) + sigc;
				sigs=((i-medias)*(i-medias)*istogrammas[i]) + sigs;
			}
			
			// calcolo delle deviazioni standard
			int varc, vars;
			
			varc=int(sigc/dc);
			vars=int(sigs/ds);

			double devc, devs;

			devc = sqrt(varc);
			devs = sqrt(vars);

			// visualizzazione dei valori ottenuti

			char pixelcar1[10];
			char pixelcar2[10];
			char pixelcar3[10];
			char pixelcar4[10];
			char pixelcar5[10];
			char pixelcar6[10];
			char pixelcar7[10];

			CString str1="Il valore della soglia ottima : ";
			CString str2="Il valore medio del primo istogramma : ";
			CString str3="Il valore medio del secondo istogramma : ";
			CString str4="La varianza del primo istogramma : ";
			CString str5="La varianza del secondo istogramma : ";
			CString str6="La deviazione standard del primo istogramma : ";
			CString str7="La deviazione standard del secondo istogramma : ";

			_itoa(thres,pixelcar1,10);
			_itoa(mediac,pixelcar2,10);
			_itoa(medias,pixelcar3,10);
			_itoa(varc,pixelcar4,10);
			_itoa(vars,pixelcar5,10);
			_itoa(devc,pixelcar6,10);
			_itoa(devs,pixelcar7,10);

			CString str = str1+pixelcar1 + "\n" + str2+pixelcar2 + "\n"+str3+pixelcar3 + "\n" + str4+pixelcar4 + "\n" + str5+pixelcar5 +"\n" + str6+pixelcar6 + "\n" + str7+pixelcar7 + "\n";
		

			// distruzione delle finestre e rilascio della memoria
			cvWaitKey(0);

			AfxMessageBox(str);


			cvDestroyWindow("window Threshold of Sobel");
			cvDestroyWindow("window gray");
			cvDestroyWindow("hist_chiari");
			cvDestroyWindow("hist_scuri");
			cvDestroyWindow("window Optimal Thresholding");
			cvReleaseImage (&src);
			cvReleaseImage (&src_gray);
			cvReleaseImage (&src_gray1);
			cvReleaseImage (&dst16s1);
			cvReleaseImage (&dst16s2);
			cvReleaseImage (&dst8u);
			cvReleaseImage (&dst32f1);
			cvReleaseImage (&dst32f2);
			cvReleaseImage (&imagec);
			cvReleaseImage (&images);



}
