// Gruppo 1Doc.cpp : implementation of the CGruppo1Doc class
//

#include "stdafx.h"
#include "Gruppo 1.h"
#include "ThreshDlg.h"
#include "MyFunctions.h"

#include "Gruppo 1Doc.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CGruppo1Doc

IMPLEMENT_DYNCREATE(CGruppo1Doc, CDocument)

BEGIN_MESSAGE_MAP(CGruppo1Doc, CDocument)
	//{{AFX_MSG_MAP(CGruppo1Doc)
	ON_COMMAND(ID_PROGETTI_1A_SOBEL, OnProgetti1aSobel)
	ON_COMMAND(ID_PROGETTI_1B_SOBEL, OnProgetti1bSobel)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CGruppo1Doc construction/destruction

CGruppo1Doc::CGruppo1Doc()
{
	// TODO: add one-time construction code here

}

CGruppo1Doc::~CGruppo1Doc()
{
}

BOOL CGruppo1Doc::OnNewDocument()
{
	if (!CDocument::OnNewDocument())
		return FALSE;

	// TODO: add reinitialization code here
	// (SDI documents will reuse this document)

	return TRUE;
}



/////////////////////////////////////////////////////////////////////////////
// CGruppo1Doc serialization

void CGruppo1Doc::Serialize(CArchive& ar)
{
	if (ar.IsStoring())
	{
		// TODO: add storing code here
	}
	else
	{
		// TODO: add loading code here
	}
}

/////////////////////////////////////////////////////////////////////////////
// CGruppo1Doc diagnostics

#ifdef _DEBUG
void CGruppo1Doc::AssertValid() const
{
	CDocument::AssertValid();
}

void CGruppo1Doc::Dump(CDumpContext& dc) const
{
	CDocument::Dump(dc);
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CGruppo1Doc commands


void CGruppo1Doc::OnProgetti1aSobel() 
{
	const char SRC[]="Immagine di partenza";
	const char SOBEL0[]="Filtro di Sobel";
	const char SOBEL[]="Filtro di Sobel sogliato";
	const char HIST1[]="Istogramma 1";
	const char HIST2[]="Istogramma 2";
		
	IplImage *src=0;
	if(OpenImage(&src,0)!=1) return;

	cvNamedWindow(SRC,CV_WINDOW_AUTOSIZE);
	cvShowImage(SRC,src);

	CvSize size=cvSize(src->width,src->height);
	IplImage *dst, *dst1, *dst2;
	
	dst=cvCreateImage(size,IPL_DEPTH_16S,1);
	// immagine per il filtro di Sobel

	dst1=cvCreateImage(size,IPL_DEPTH_32F,1);
	// copia di dst a 32 bit per l'uso di iplMinMaxFP

	dst2=cvCreateImage(size,IPL_DEPTH_8U,1);
	// immagine finale sogliata

	// applicazione del filtro di Sobel
	cvSobel(src,dst,1,1);
	iplAbs(dst,dst);
	cvConvertScale(dst,dst1,1.0,0.0); // conversione a 32 bit

	// normalizzazione di dst1 rispetto al valore massimo
	float min,max;
	iplMinMaxFP(dst1,&min,&max);
	float value=255/max;
	iplMultiplySFP(dst1,dst1,value);

	// conversione a 8 bit e sogliatura
	cvConvertScale(dst1,dst2,1.0,0.0);
	cvNamedWindow(SOBEL0,CV_WINDOW_AUTOSIZE);
	
	cvShowImage(SOBEL0,dst2);
	CThreshDlg dialog;
	dialog.DoModal();
	int threshold=dialog.m_thresh;
	cvDestroyWindow(SOBEL0);

	cvThreshold(dst2,dst2,threshold,255,CV_THRESH_BINARY_INV);

	// creazione degli istogrammi
	IplImage *imgHist1=0, *imgHist2=0;
	Histogram(src,&imgHist1,0,"Istogramma senza maschera",CV_RGB(255,0,0));
	Histogram(src,&imgHist2,dst2,"Istogramma con maschera",CV_RGB(255,255,0));

	// visualizzazione delle immagini
	cvNamedWindow(SOBEL,CV_WINDOW_AUTOSIZE);
	cvNamedWindow(HIST1,CV_WINDOW_AUTOSIZE);
	cvNamedWindow(HIST2,CV_WINDOW_AUTOSIZE);

	cvShowImage(SOBEL,dst2);
	cvShowImage(HIST1,imgHist1);
	cvShowImage(HIST2,imgHist2);
	cvSaveImage("Sobel.bmp",dst2);
	cvSaveImage("Hist1.bmp",imgHist1);
	cvSaveImage("Hist2.bmp",imgHist2);

	cvWaitKey(0);

	cvDestroyWindow(SRC);
	cvDestroyWindow(SOBEL);
	cvDestroyWindow(HIST1);
	cvDestroyWindow(HIST2);

	cvReleaseImage(&src);
	cvReleaseImage(&dst);
	cvReleaseImage(&dst1);
	cvReleaseImage(&dst2);
	cvReleaseImage(&imgHist1);
	cvReleaseImage(&imgHist2);
}


void CGruppo1Doc::OnProgetti1bSobel() 
{
	const char SRC[]="Immagine di partenza";
	const char SOBEL0[]="Filtro di Sobel";
	const char SOBEL[]="Filtro di Sobel sogliato";
	const char HIST1[]="Istogramma 1";
	const char HIST2[]="Istogramma 2";
		
	IplImage *src=0;
	if(OpenImage(&src,0)!=1) return;


	cvNamedWindow(SRC,CV_WINDOW_AUTOSIZE);
	cvShowImage(SRC,src);

	CvSize size=cvSize(src->width,src->height);
	IplImage *dst, *dst1, *dst2, *dstx, *dsty;
	
	dstx=cvCreateImage(size,IPL_DEPTH_16S,1);
	// immagine per il filtro di Sobel lungo l'asse x

	dsty=cvCreateImage(size,IPL_DEPTH_16S,1);
	// immagine per il filtro di Sobel lungo l'asse y

	dst=cvCreateImage(size,IPL_DEPTH_16S,1);
	// immagine per la somma di dstx e dsty

	dst1=cvCreateImage(size,IPL_DEPTH_32F,1);
	// copia di dst a 32 bit per l'uso di iplMinMaxFP

	dst2=cvCreateImage(size,IPL_DEPTH_8U,1);
	// immagine finale sogliata

	// applicazione del filtro di Sobel
	cvSobel(src,dstx,1,0);
	cvSobel(src,dsty,0,1);
	iplAbs(dstx,dstx);
	iplAbs(dsty,dsty);
	iplAdd(dstx,dsty,dst);
	cvReleaseImage(&dstx);
	cvReleaseImage(&dsty);
	cvConvertScale(dst,dst1,1.0,0.0); // conversione a 32 bit

	// normalizzazione di dst1 rispetto al valore massimo
	float min,max;
	iplMinMaxFP(dst1,&min,&max);
	float value=255/max;
	iplMultiplySFP(dst1,dst1,value);

	// conversione a 8 bit e sogliatura
	cvConvertScale(dst1,dst2,1.0,0.0);
	cvNamedWindow(SOBEL0,CV_WINDOW_AUTOSIZE);
	
	cvShowImage(SOBEL0,dst2);
	CThreshDlg dialog;
	dialog.DoModal();
	int threshold=dialog.m_thresh;
	cvDestroyWindow(SOBEL0);

	cvThreshold(dst2,dst2,threshold,255,CV_THRESH_BINARY_INV);

	// creazione degli istogrammi
	IplImage *imgHist1=0, *imgHist2=0;
	Histogram(src,&imgHist1,0,"Istogramma senza maschera",CV_RGB(255,0,0));
	Histogram(src,&imgHist2,dst2,"Istogramma con maschera",CV_RGB(255,255,0));

	// visualizzazione delle immagini
	cvNamedWindow(SOBEL,CV_WINDOW_AUTOSIZE);
	cvNamedWindow(HIST1,CV_WINDOW_AUTOSIZE);
	cvNamedWindow(HIST2,CV_WINDOW_AUTOSIZE);

	cvShowImage(SOBEL,dst2);
	cvShowImage(HIST1,imgHist1);
	cvShowImage(HIST2,imgHist2);
	cvSaveImage("Sobel.bmp",dst2);
	cvSaveImage("Hist1.bmp",imgHist1);
	cvSaveImage("Hist2.bmp",imgHist2);

	cvWaitKey(0);

	cvDestroyWindow(SRC);
	cvDestroyWindow(SOBEL);
	cvDestroyWindow(HIST1);
	cvDestroyWindow(HIST2);

	cvReleaseImage(&src);
	cvReleaseImage(&dst);
	cvReleaseImage(&dst1);
	cvReleaseImage(&dst2);
	cvReleaseImage(&imgHist1);
	cvReleaseImage(&imgHist2);
}
